xref: /openbmc/linux/scripts/link-vmlinux.sh (revision 161f4089)
1#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11#   ^
12#   |
13#   +-< $(KBUILD_VMLINUX_INIT)
14#   |   +--< init/version.o + more
15#   |
16#   +--< $(KBUILD_VMLINUX_MAIN)
17#   |    +--< drivers/built-in.o mm/built-in.o + more
18#   |
19#   +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35	if [ "${quiet}" != "silent_" ]; then
36		printf "  %-7s %s\n" ${1} ${2}
37	fi
38}
39
40# Link of vmlinux.o used for section mismatch analysis
41# ${1} output file
42modpost_link()
43{
44	${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT}                   \
45		--start-group ${KBUILD_VMLINUX_MAIN} --end-group
46}
47
48# Link of vmlinux
49# ${1} - optional extra .o files
50# ${2} - output file
51vmlinux_link()
52{
53	local lds="${objtree}/${KBUILD_LDS}"
54
55	if [ "${SRCARCH}" != "um" ]; then
56		${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}                  \
57			-T ${lds} ${KBUILD_VMLINUX_INIT}                     \
58			--start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59	else
60		${CC} ${CFLAGS_vmlinux} -o ${2}                              \
61			-Wl,-T,${lds} ${KBUILD_VMLINUX_INIT}                 \
62			-Wl,--start-group                                    \
63				 ${KBUILD_VMLINUX_MAIN}                      \
64			-Wl,--end-group                                      \
65			-lutil ${1}
66		rm -f linux
67	fi
68}
69
70
71# Create ${2} .o file with all symbols from the ${1} object file
72kallsyms()
73{
74	info KSYM ${2}
75	local kallsymopt;
76
77	if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78		kallsymopt="${kallsymopt} --symbol-prefix=_"
79	fi
80
81	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
82		kallsymopt="${kallsymopt} --all-symbols"
83	fi
84
85	kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
86
87	local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
88		      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
89
90	${NM} -n ${1} | \
91		scripts/kallsyms ${kallsymopt} | \
92		${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
93}
94
95# Create map file with all symbols from ${1}
96# See mksymap for additional details
97mksysmap()
98{
99	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
100}
101
102sortextable()
103{
104	${objtree}/scripts/sortextable ${1}
105}
106
107# Delete output files in case of error
108trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
109cleanup()
110{
111	rm -f .old_version
112	rm -f .tmp_System.map
113	rm -f .tmp_kallsyms*
114	rm -f .tmp_version
115	rm -f .tmp_vmlinux*
116	rm -f System.map
117	rm -f vmlinux
118	rm -f vmlinux.o
119}
120
121#
122#
123# Use "make V=1" to debug this script
124case "${KBUILD_VERBOSE}" in
125*1*)
126	set -x
127	;;
128esac
129
130if [ "$1" = "clean" ]; then
131	cleanup
132	exit 0
133fi
134
135# We need access to CONFIG_ symbols
136case "${KCONFIG_CONFIG}" in
137*/*)
138	. "${KCONFIG_CONFIG}"
139	;;
140*)
141	# Force using a file from the current directory
142	. "./${KCONFIG_CONFIG}"
143esac
144
145#link vmlinux.o
146info LD vmlinux.o
147modpost_link vmlinux.o
148
149# modpost vmlinux.o to check for section mismatches
150${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
151
152# Update version
153info GEN .version
154if [ ! -r .version ]; then
155	rm -f .version;
156	echo 1 >.version;
157else
158	mv .version .old_version;
159	expr 0$(cat .old_version) + 1 >.version;
160fi;
161
162# final build of init/
163${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
164
165kallsymso=""
166kallsyms_vmlinux=""
167if [ -n "${CONFIG_KALLSYMS}" ]; then
168
169	# kallsyms support
170	# Generate section listing all symbols and add it into vmlinux
171	# It's a three step process:
172	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
173	#     but __kallsyms is empty.
174	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
175	#     the right size
176	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
177	#     the right size, but due to the added section, some
178	#     addresses have shifted.
179	#     From here, we generate a correct .tmp_kallsyms2.o
180	# 2a) We may use an extra pass as this has been necessary to
181	#     woraround some alignment related bugs.
182	#     KALLSYMS_EXTRA_PASS=1 is used to trigger this.
183	# 3)  The correct ${kallsymso} is linked into the final vmlinux.
184	#
185	# a)  Verify that the System.map from vmlinux matches the map from
186	#     ${kallsymso}.
187
188	kallsymso=.tmp_kallsyms2.o
189	kallsyms_vmlinux=.tmp_vmlinux2
190
191	# step 1
192	vmlinux_link "" .tmp_vmlinux1
193	kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
194
195	# step 2
196	vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
197	kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
198
199	# step 2a
200	if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
201		kallsymso=.tmp_kallsyms3.o
202		kallsyms_vmlinux=.tmp_vmlinux3
203
204		vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
205
206		kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
207	fi
208fi
209
210info LD vmlinux
211vmlinux_link "${kallsymso}" vmlinux
212
213if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
214	info SORTEX vmlinux
215	sortextable vmlinux
216fi
217
218info SYSMAP System.map
219mksysmap vmlinux System.map
220
221# step a (see comment above)
222if [ -n "${CONFIG_KALLSYMS}" ]; then
223	mksysmap ${kallsyms_vmlinux} .tmp_System.map
224
225	if ! cmp -s System.map .tmp_System.map; then
226		echo >&2 Inconsistent kallsyms data
227		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
228		cleanup
229		exit 1
230	fi
231fi
232
233# We made a new kernel - delete old version file
234rm -f .old_version
235